#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <vga.h>
#include <vgagl.h>
#include "staipan.h"

char    firm[23],
        fancy_num[13];

char    *item[] = { "Opium", "Silk", "Arms", "General Cargo" };

char    *location[] = { "At sea", "Hong Kong", "Shanghai", "Nagasaki",
                        "Saigon", "Manila", "Singapore", "Batavia" };

char    *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

char    *st[] = { "Critical", "  Poor", "  Fair",
                  "  Good", " Prime", "Perfect" };

float   cash         = 0,
        bank         = 0,
        debt         = 0,
        booty        = 0,
        ec           = 20,
        ed           = .5;

long    price[4];

int     base_price[4][8] = { {1000, 11, 16, 15, 14, 12, 10, 13},
                             {100,  11, 14, 15, 16, 10, 13, 12},
                             {10,   12, 16, 10, 11, 13, 14, 15},
                             {1,    10, 11, 12, 13, 14, 15, 16} };

int     hkw_[4],
        hold_[4];

int     hold         = 0,
        capacity     = 60,
        guns         = 0,
        bp           = 0,
        damage       = 0,
        month        = 1,
        year         = 1860,
        li           = 0,
        port         = 1,
        wu_warn      = 0,
        wu_bailout   = 0,
        cursor       = 0;

int main(void)
{
   int choice;

   struct itimerval interval;

   srand(getpid());

   vga_init();
   if (vga_hasmode(G640x480x256) == 0)
   {
      printf("\nstaipan: Your hardware does not support graphics mode G640x480x256\n");
      exit(1);
   }
   vga_setmode(G640x480x256);
   gl_setcontextvga(G640x480x256);   

   normal = malloc(256 * 14 * 16 * BYTESPERPIXEL);
   reverse = malloc(256 * 14 * 16 * BYTESPERPIXEL);
   bold = malloc(256 * 14 * 16 * BYTESPERPIXEL);
   boldrev = malloc(256 * 14 * 16 * BYTESPERPIXEL);
   gl_expandfont(14, 16, 2, mainfont, normal);
   gl_expandfont(14, 16, 2, main_inv, reverse);
   gl_expandfont(14, 16, 2, boldfont, bold);
   gl_expandfont(14, 16, 2, bold_inv, boldrev);

   signal(SIGVTALRM, catch_alarm);
   interval.it_interval.tv_sec = 0;
   interval.it_interval.tv_usec = 200000;
   interval.it_value.tv_sec = 0;
   interval.it_value.tv_usec = 200000;
   setitimer(ITIMER_VIRTUAL, &interval, NULL);

   splash_intro();
   name_firm();
   cash_or_guns();
   set_prices();

   for (;;)
   {
      choice = 0;

      port_stats();

      if ((port == 1) && (li == 0) && (cash > 0))
      {
         li_yuen_extortion();
      }

      if ((port == 1) && (damage > 0))
      {
         mchenry();
      }

      if ((port == 1) && (debt >= 10000) && (wu_warn == 0))
      {
         int braves = rand()%100 + 50;

         s_clrtobot(LINE1);
         gl_write(LEFT, LINE1, "Comprador's Report");
         gl_printf(LEFT, LINE3, "Elder Brother Wu has sent %d braves", braves);
         gl_write(LEFT, LINE4, "to escort you to the Wu mansion, Taipan.");

         s_timeout(3);

         s_clrtobot(LINE3);
         gl_write(LEFT, LINE3, "Elder Brother Wu reminds you of the");
         gl_write(LEFT, LINE4, "Confucian ideal of personal worthiness,");
         gl_write(LEFT, LINE5, "and how this applies to paying one's");
         gl_write(LEFT, LINE6, "debts.");

         s_timeout(3);

         s_clrtobot(LINE3);
         gl_write(LEFT, LINE3, "He is reminded of a fabled barbarian");
         gl_write(LEFT, LINE4, "who came to a bad end, after not caring");
         gl_write(LEFT, LINE5, "for his obligations.");
         gl_write(LEFT, LINE7, "He hopes no such fate awaits you, his");
         gl_write(LEFT, LINE8, "friend, Taipan.");

         s_timeout(5);

         wu_warn = 1;
      }

      if (port == 1)
      {
         elder_brother_wu();
      }

      if (rand()%4 == 0)
      {
         if (rand()%2 == 0)
         {
            new_ship();
         } else if (guns < 1000) {
            new_gun();
         }
      }

      if ((port != 1) && (rand()%18 == 0) && (hold_[0] > 0))
      {
         float fine = ((cash / 1.8) * ((float) rand() / RAND_MAX)) + 1;

         hold += hold_[0];
         hold_[0] = 0;
         cash -= fine;

         port_stats();

         fancy_numbers(fine, fancy_num);
         s_clrtobot(LINE1);
         gl_write(LEFT, LINE1, "Comprador's Report");
         gl_write(LEFT, LINE3, "Bad Joss!!");
         gl_write(LEFT, LINE4, "The local authorities have seized your");
         gl_write(LEFT, LINE5, "Opium cargo and have also fined you");
         gl_printf(LEFT, LINE6, "%s, Taipan!", fancy_num);

         s_timeout(5);
      }

      if ((rand()%50 == 0) &&
          ((hkw_[0] + hkw_[1] + hkw_[2] + hkw_[3]) > 0))
      {
         int i;

         for (i = 0; i < 4; i++)
         {
            hkw_[i] = ((hkw_[i] / 1.8) * ((float) rand() / RAND_MAX));
         }

         port_stats();

         s_clrtobot(LINE1);
         gl_write(LEFT, LINE1, "Comprador's Report");
         gl_write(LEFT, LINE3, "Messenger reports large theft");
         gl_write(LEFT, LINE4, "from warehouse, Taipan.");

         s_timeout(5);
      }

      if (rand()%20 == 0)
      {
         if (li > 0) { li++; }
         if (li == 4) { li = 0; }
      }

      if ((port != 1) && (li == 0) && (rand()%4 != 0))
      {
         s_clrtobot(LINE1);
         gl_write(LEFT, LINE1, "Comprador's Report");
         gl_write(LEFT, LINE3, "Li Yuen has sent a Lieutenant,");
         gl_write(LEFT, LINE4, "Taipan.  He says his admiral wishes");
         gl_write(LEFT, LINE5, "to see you in Hong Kong, posthaste!");

         s_timeout(3);
      }

      if (rand()%9 == 0)
      {
         good_prices();
      }

      if ((cash > 25000) && (rand()%20 == 0))
      {
         float robbed = ((cash / 1.4) * ((float) rand() / RAND_MAX));

         cash -= robbed;
         port_stats();

         fancy_numbers(robbed, fancy_num);
         s_clrtobot(LINE1);
         gl_write(LEFT, LINE1, "Comprador's Report");
         gl_write(LEFT, LINE3, "Bad Joss!!");
         gl_write(LEFT, LINE4, "You've been beaten up and");
         gl_printf(LEFT, LINE5, "robbed of %s in cash, Taipan!!", fancy_num);

         s_timeout(5);
      }

      for (;;)
      {
         while ((choice != 'Q') && (choice != 'q'))
         {
            switch (choice = port_choices())
            {
               case 'B':
               case 'b':
                  buy();
                  break;

               case 'S':
               case 's':
                  sell();
                  break;

               case 'V':
               case 'v':
                  visit_bank();
                  break;

               case 'T':
               case 't':
                  transfer();
                  break;

               case 'R':
               case 'r':
                  retire();
            }

            port_stats();
         }

         choice = 0;
         if (hold >= 0)
         {
            quit();
            break;
         } else {
            overload();
         }
      }
   }

   signal(SIGVTALRM, SIG_IGN);
   interval.it_interval.tv_usec = 0;
   interval.it_value.tv_usec = 0;
   setitimer(ITIMER_VIRTUAL, &interval, NULL);

   gl_clearscreen(0);
   vga_setmode(TEXT);

   return EXIT_SUCCESS;
}

void splash_intro(void)
{
   int input = 0,
       i;

   gl_clearscreen(0);
   gl_setfont(14, 16, normal);
   intro_ship();
   gl_write(LEFT, (ROW2 - 2), "--------------------------");
   gl_write(LEFT, (ROW3 - 2), "A game based on the China");
   gl_write(COL3, (ROW4 - 2), "trade of the 1800's");
   gl_write(COL29, (ROW1 - 4), "Created by:");
   gl_write(COL29, (ROW2 - 2), "Art Canfil");
   for (i = COL28; i <= COL39; i++)
   {
      gl_printf(i, ROW3, "%c", DOUBLE);
   }
   gl_setfont(14, 16, bold);
   gl_write(COL31, (ROW4 + 4), "SVGA");
   gl_setfont(14, 16, normal);
   gl_write(COL35, (ROW4 + 4), "lib");
   gl_write(COL29, (ROW5 + 4), "Program by:");
   gl_setfont(14, 16, bold);
   gl_write(COL30, ROW7, "Jay Link");
   gl_setfont(14, 16, normal);
   for (i = COL28; i <= COL39; i++)
   {
      gl_printf(i, ROW8, "%c", DOUBLE);
   }
   gl_write(COL30, (ROW9 + 4), "Copyright");
   gl_printf(COL30, (ROW10 + 4), "%c%c1982 by", COPYLEFT, COPYRIGHT);
   gl_setfont(14, 16, bold);
   gl_write(COL30, ROW12, "Avalanche");
   gl_write(COL29, ROW13, "Productions");
   gl_write(COL32, ROW14, "Inc.");
   gl_setfont(14, 16, normal);
   for (i = COL28; i <= COL39; i++)
   {
      gl_printf(i, ROW15, "%c", DOUBLE);
   }
   gl_write(COL30, LINE2, "Press the");
   gl_setfont(14, 16, boldrev);
   gl_write(COL30, LINE3, "'ESC'");
   gl_setfont(14, 16, normal);
   gl_write(COL36, LINE3, "key");
   gl_write(COL30, LINE4, "to start.");

   while (input != '\33')
   {
      input = vga_getch();
      if (input == '\33')
      {
         if ((input = vga_getkey()) == 0)
         {
            input = '\33';
         } else {
            while (input != 0) { input = vga_getkey(); }
         }
      }
   }

   return;
}

void s_clrtobot(int line)
{
   gl_fillbox(LEFT, line, 639, 479, 0);
}

void s_clearline(int row)
{
   int i;

   for (i = LEFT; i <= COL39; i += CHARWIDTH)
   {
      gl_write(i, row, " ");
   }

   return;
}

int s_timeout(int seconds)
{
   int input = 0,
       elapsed = 0;

   while (((input = vga_getkey()) == 0) && ((elapsed / 10) < seconds))
   {
      usleep(100000);
      elapsed += 1;
   }

   return input;
}

void catch_alarm(int vtalrm)
{
   cursor = !cursor;
   signal(SIGVTALRM, catch_alarm);
}

int get_one(int x, int y)
{
   char output[2];

   int  input,
        choice = 0,
        character = 0;

   while ((input = vga_getkey()) != '\n')
   {
      if (((input == 8) || (input == 127)) && (character == 1)) {
         x -= 14;
         gl_write(x, y, "  ");
         character--;
      } else if (input == '\33') {
         while (input != 0) { input = vga_getkey(); }
      } else if ((character == 0) && (input != 0) &&
                 (input != 8) && (input < 127)) {
         sprintf(output, "%c", input);
         gl_write(x, y, output);
         choice = input;
         x += 14;
         character++;
      }

      if (cursor == 1)
      {
         gl_write(x, y, "_");
      } else {
         gl_write(x, y, " ");
      }
   }

   gl_write(x, y, "  ");

   return choice;
}

long get_num(int x, int y, int maxlen)
{
   char number[maxlen + 1];

   int  input,
        character = 0;

   long amount;

   while ((input = vga_getkey()) != '\n')
   {
      if (((input == 8) || (input == 127)) && (character > 0)) {
         number[character] = '\0';
         gl_write(((character * CHARWIDTH) + x), y, "  ");
         character--;
         gl_write(x, y, number);
      } else if (input == '\33') {
         while (input != 0) { input = vga_getkey(); }
      } else if (((input == 'A') || (input == 'a')) &&
                 (character == 0) && (maxlen > 1)) {
         number[character] = input;
         character++;
         number[character] = '\0';
         gl_write(x, y, number);
      } else if ((character < maxlen) && (input != 0) &&
                 (input != 8) && (input != 127) &&
                 (input > 47) && (input < 58)) {
         number[character] = input;
         character++;
         number[character] = '\0';
         gl_write(x, y, number);
      }

      if (cursor == 1)
      {
         gl_write(((character * CHARWIDTH) + x), y, "_");
      } else {
         gl_write(((character * CHARWIDTH) + x), y, " ");
      }
   }

   number[character] = '\0';
   if ((strcmp(number, "A") == 0) || (strcmp(number, "a") == 0))
   {
      amount = -1;
   } else {
      amount = strtol(number, (char **)NULL, 10);
   }

   gl_write(x, y, "  ");

   return amount;
}

void name_firm(void)
{
   int  input,
        x = COL13,
        y,
        character = 0,
        i;

   gl_clearscreen(0);
   gl_setfont(14, 16, normal);

   gl_printf(LEFT, ROW7, "%c", ULCORNER);
   for (i = COL1; i <= COL39; i += CHARWIDTH)
   {
      gl_printf(i, ROW7, "%c", SINGLETOP);
   }
   gl_printf(COL39, ROW7, "%c", URCORNER);
   for (i = ROW8; i <= ROW15; i += CHARHEIGHT)
   {
      gl_printf(LEFT, i, "%c", SINGLEVER);
      gl_printf(COL39, i, "%c", SINGLEVER);
   }
   gl_printf(LEFT, LINE1, "%c", LLCORNER);
   for (i = COL1; i <= COL39; i += CHARWIDTH)
   {
      gl_printf(i, LINE1, "%c", SINGLEBOT);
   }
   gl_printf(COL39, LINE1, "%c", LRCORNER);

   gl_write(COL6, ROW9, "Taipan,");
   gl_write(COL2, ROW11, "What will you name your");
   gl_write(COL6, ROW13, "Firm:");
   gl_write(COL13, ROW14, "----------------------");

   gl_setfont(14, 16, bold);
   y = ROW13;
   while (((input = vga_getkey()) != '\n') && (character <= 22))
   {
      if (((input == 8) || (input == 127)) && (character > 0)) {
         x -= 14;
         gl_write(x, y, "  ");
         firm[character] = '\0';
         character--;
      } else if (input == '\33') {
         while (input != 0) { input = vga_getkey(); }
      } else if ((character < 22) && (input != 0) &&
                 (input != 8) && (input < 127)) {
         gl_printf(x, y, "%c", input);
         firm[character] = input;
         x += 14;
         character++;
      }

      if (cursor == 1)
      {
         gl_write(x, y, "_");
      } else {
         gl_write(x, y, " ");
      }
   }
   gl_setfont(14, 16, normal);

   firm[character] = '\0';

   return;
}

void cash_or_guns(void)
{
   int choice = 0;

   gl_clearscreen(0);
   gl_write(LEFT, ROW5, "Do you want to start . . .");
   gl_write(COL2, ROW8, "1) With cash (and a debt)");
   gl_write(COL16, ROW11, ">> or <<");
   gl_write(COL2, ROW14, "2) With five guns and no cash");
   gl_write(COL16, LINE1, "(But no debt!)");
   gl_write(COL10, LINE4, "?");

   while ((choice != '1') && (choice != '2'))
   {
      choice = get_one(COL11, LINE4);
   }

   if (choice == '1')
   {
      cash = 400;
      debt = 5000;
      hold = 60;
      guns = 0;
      li = 0;
      bp = 10;
   } else {
      cash = 0;
      debt = 0;
      hold = 10;
      guns = 5;
      li = 1;
      bp = 7;
   }

   return;
}

void set_prices(void)
{
   price[0] = base_price[0][port] / 2 * (rand()%3 + 1) * base_price[0][0];
   price[1] = base_price[1][port] / 2 * (rand()%3 + 1) * base_price[1][0];
   price[2] = base_price[2][port] / 2 * (rand()%3 + 1) * base_price[2][0];
   price[3] = base_price[3][port] / 2 * (rand()%3 + 1) * base_price[3][0];
   return;
}

void port_stats(void)
{
   int  in_use,
        status = 100 - ((float) damage / capacity * 100),
        spacer,
        i;

   gl_clearscreen(0);
   gl_setfont(14, 16, normal);

   spacer = 12 - (strlen(firm) / 2);
   gl_write((LEFT + (CHARWIDTH * spacer)), TOP, "Firm:");
   gl_setfont(14, 16, bold);
   gl_printf((LEFT + (CHARWIDTH * (spacer + 6))), TOP, "%s", firm);
   gl_setfont(14, 16, normal);
   gl_write((LEFT + (CHARWIDTH * (spacer + 6 + strlen(firm)))), TOP, ", Hong Kong");

   gl_printf(LEFT, ROW1, "%c", ULCORNER);
   for (i = COL1; i <= COL26; i += CHARWIDTH)
   {
      gl_printf(i, ROW1, "%c", SINGLETOP);
   }
   gl_printf(COL27, ROW1, "%c", URCORNER);
   for (i = ROW2; i <= ROW6; i += CHARHEIGHT)
   {
      gl_printf(LEFT, i, "%c", SINGLEVER);
      gl_printf(COL27, i, "%c", SINGLEVER);
   }
   gl_printf(LEFT, ROW7, "%c", DOUBLELT);
   for (i = COL1; i <= COL26; i += CHARWIDTH)
   {
      gl_printf(i, ROW7, "%c", DOUBLE);
   }
   gl_printf(COL27, ROW7, "%c", DOUBLERT);
   for (i = ROW8; i <= ROW12; i += CHARHEIGHT)
   {
      gl_printf(LEFT, i, "%c", SINGLEVER);
      gl_printf(COL27, i, "%c", SINGLEVER);
   }
   gl_printf(LEFT, ROW13, "%c", LLCORNER);
   for (i = COL1; i <= COL26; i += CHARWIDTH)
   {
      gl_printf(i, ROW13, "%c", SINGLEBOT);
   }
   gl_printf(COL27, ROW13, "%c", LRCORNER);

   gl_write(COL1, ROW2, "Hong Kong Warehouse");
   gl_write(COL1, ROW3, "   Opium");
   gl_write(COL1, ROW4, "   Silk");
   gl_write(COL1, ROW5, "   Arms");
   gl_write(COL1, ROW6, "   General");

   fancy_numbers(hkw_[0], fancy_num);
   gl_write(COL13, ROW3, fancy_num);
   fancy_numbers(hkw_[1], fancy_num);
   gl_write(COL13, ROW4, fancy_num);
   fancy_numbers(hkw_[2], fancy_num);
   gl_write(COL13, ROW5, fancy_num);
   fancy_numbers(hkw_[3], fancy_num);
   gl_write(COL13, ROW6, fancy_num);

   gl_write(COL20, ROW3, "In use:");
   in_use = hkw_[0] + hkw_[1] + hkw_[2] + hkw_[3];
   fancy_numbers(in_use, fancy_num);
   gl_write(COL21, ROW4, fancy_num);
   gl_write(COL20, ROW5, "Vacant:");
   fancy_numbers((10000 - in_use), fancy_num);
   gl_write(COL21, ROW6, fancy_num);

   gl_write(COL1, ROW8, "Hold");
   if (hold >= 0)
   {
      fancy_numbers(hold, fancy_num);
      gl_write(COL6, ROW8, fancy_num);
   } else {
      gl_setfont(14, 16, reverse);
      gl_write(COL6, ROW8, "Overload");
      gl_setfont(14, 16, normal);
   }

   gl_write(COL1, ROW9, "   Opium");
   gl_write(COL1, ROW10, "   Silk");
   gl_write(COL1, ROW11, "   Arms");
   gl_write(COL1, ROW12, "   General");

   fancy_numbers(hold_[0], fancy_num);
   gl_write(COL13, ROW9, fancy_num);
   fancy_numbers(hold_[1], fancy_num);
   gl_write(COL13, ROW10, fancy_num);
   fancy_numbers(hold_[2], fancy_num);
   gl_write(COL13, ROW11, fancy_num);
   fancy_numbers(hold_[3], fancy_num);
   gl_write(COL13, ROW12, fancy_num);

   gl_write(COL16, ROW8, "Guns");
   fancy_numbers(guns, fancy_num);
   gl_write(COL21, ROW8, fancy_num);

   gl_write(COL32, ROW2, "Date");
   gl_write(COL29, ROW3, "15");
   gl_setfont(14, 16, reverse);
   gl_write(COL32, ROW3, months[month - 1]);
   gl_setfont(14, 16, normal);
   fancy_numbers(year, fancy_num);
   gl_write(COL36, ROW3, fancy_num);

   gl_write(COL30, ROW5, "Location");

   spacer = (9 - strlen(location[port])) / 2;
   gl_setfont(14, 16, reverse);
   gl_write(((spacer * CHARWIDTH) + COL30), ROW6, location[port]);
   gl_setfont(14, 16, normal);

   gl_write(COL32, ROW8, "Debt");
   fancy_numbers(debt, fancy_num);
   spacer = (12 - strlen(fancy_num)) / 2;
   gl_setfont(14, 16, reverse);
   gl_write(((spacer * CHARWIDTH) + COL28), ROW9, fancy_num);
   gl_setfont(14, 16, normal);

   gl_write(COL29, ROW11, "Ship Status");
   i = status / 20;
   if (i < 2)
   {
      gl_setfont(14, 16, reverse);
      gl_write(COL38, ROW12, "  ");
   }
   gl_printf(COL29, ROW12, "%s:%d", st[i], status);
   gl_setfont(14, 16, normal);

   gl_write(LEFT, ROW14, "Cash:");
   fancy_numbers(cash, fancy_num);
   gl_write(COL5, ROW14, fancy_num);
   gl_write(COL20, ROW14, "Bank:");
   fancy_numbers(bank, fancy_num);
   gl_write(COL25, ROW14, fancy_num);

   for (i = LEFT; i <= COL39; i += CHARWIDTH)
   {
      gl_printf(i, ROW15, "%c", SINGLETOP);
   }
}

int port_choices(void)
{
   int choice = 0;

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Taipan, present prices per unit here are");
   gl_write(LEFT, LINE4, "   Opium:          Silk:\n");
   gl_write(LEFT, LINE5, "   Arms:           General:\n");
   fancy_numbers(price[0], fancy_num);
   gl_write(COL10, LINE4, fancy_num);
   fancy_numbers(price[1], fancy_num);
   gl_write(COL25, LINE4, fancy_num);
   fancy_numbers(price[2], fancy_num);
   gl_write(COL9, LINE5, fancy_num);
   fancy_numbers(price[3], fancy_num);
   gl_write(COL28, LINE5, fancy_num);

   for (;;)
   {
      s_clrtobot(LINE7);

      if (port == 1)
      {
         if ((cash + bank) >= 1000000)
         {
            gl_write(LEFT, LINE7, "Shall I Buy, Sell, Visit bank, Transfer");
            gl_write(LEFT, LINE8, "cargo, Quit trading, or Retire?");

            choice = get_one(478, LINE8);
            if ((choice == 'B') || (choice == 'b') ||
                (choice == 'S') || (choice == 's') ||
                (choice == 'V') || (choice == 'v') ||
                (choice == 'T') || (choice == 't') ||
                (choice == 'Q') || (choice == 'q') ||
                (choice == 'R') || (choice == 'r'))
            {
               break;
            }
         } else {
            gl_write(LEFT, LINE7, "Shall I Buy, Sell, Visit bank, Transfer");
            gl_write(LEFT, LINE8, "cargo, or Quit trading?");

            choice = get_one(364, LINE8);
            if ((choice == 'B') || (choice == 'b') ||
                (choice == 'S') || (choice == 's') ||
                (choice == 'V') || (choice == 'v') ||
                (choice == 'T') || (choice == 't') ||
                (choice == 'Q') || (choice == 'q'))
            {
               break;
            }
         }
      } else {
         gl_write(LEFT, LINE7, "Shall I Buy, Sell, or Quit trading?");

         choice = get_one(532, LINE7);
         if ((choice == 'B') || (choice == 'b') ||
             (choice == 'S') || (choice == 's') ||
             (choice == 'Q') || (choice == 'q'))
         {
            break;
         }
      }
   }

   return choice;
}

void buy(void)
{
   char space[5];

   int  choice = 0;

   long afford,
        amount;

   for (;;)
   {
      s_clrtobot(LINE7);
      gl_write(LEFT, LINE7, "What do you wish me to buy, Taipan?");

      choice = get_one(534, LINE7);

      if ((choice == 'O') || (choice == 'o'))
      {
         choice = 0;
         break;
      } else if ((choice == 'S') || (choice == 's')) {
         choice = 1;
         break;
      } else if ((choice == 'A') || (choice == 'a')) {
         choice = 2;
         break;
      } else if ((choice == 'G') || (choice == 'g')) {
         choice = 3;
         break;
      }
   }

   for (;;)
   {
      s_clrtobot(LINE7);
      gl_printf(LEFT, LINE7, "How much %s shall", item[choice]);
      gl_write(LEFT, LINE8, "I buy, Taipan?");

      afford = cash / price[choice];
      if (afford < 100)
      {
         strcpy(space, "    ");
      } else if (afford < 10000) {
         strcpy(space, "   ");
      } else if (afford < 1000000) {
         strcpy(space, "  ");
      } else if (afford < 100000000) {
         strcpy(space, " ");
      } else {
         strcpy(space, "");
      }
      gl_setfont(14, 16, reverse);
      gl_write((LEFT + (CHARWIDTH * 30)), LINE6, " You can ");
      gl_write((LEFT + (CHARWIDTH * 30)), LINE7, "  afford ");
      gl_write((LEFT + (CHARWIDTH * 30)), LINE8, "         ");
      gl_printf((LEFT + (CHARWIDTH * 30)), LINE8, "%s%ld", space, afford);
      gl_setfont(14, 16, normal);

      amount = get_num(240, LINE8, 9);
      if (amount == -1)
      {
         amount = afford;
      }
      if (amount <= afford)
      {
         break;
      }
   }

   cash -= (amount * price[choice]);
   hold_[choice] += amount;
   hold -= amount;

   return;
}

void sell(void)
{
   int  choice = 0;

   long amount;

   for (;;)
   {
      s_clrtobot(LINE7);
      gl_write(LEFT, LINE7, "What do you wish me to sell, Taipan?");

      choice = get_one(548, LINE7);

      if ((choice == 'O') || (choice == 'o'))
      {
         choice = 0;
         break;
      } else if ((choice == 'S') || (choice == 's')) {
         choice = 1;
         break;
      } else if ((choice == 'A') || (choice == 'a')) {
         choice = 2;
         break;
      } else if ((choice == 'G') || (choice == 'g')) {
         choice = 3;
         break;
      }
   }

   for (;;)
   {
      s_clrtobot(LINE7);
      gl_printf(LEFT, LINE7, "How much %s shall", item[choice]);
      gl_write(LEFT, LINE8, "I sell, Taipan?");

      amount = get_num(254, LINE8, 9);

      if (amount == -1)
      {
         amount = hold_[choice];
      }
      if (hold_[choice] >= amount)
      {
         hold_[choice] -= amount;
         break;
      }
   }

   cash += (amount * price[choice]);
   hold += amount;

   return;
}

void visit_bank(void)
{
   long amount = 0;

   for (;;)
   {
      s_clrtobot(LINE1);

      gl_write(LEFT, LINE1, "Comprador's Report");
      gl_write(LEFT, LINE3, "How much will you deposit?");

      amount = get_num(408, LINE3, 9);
      if (amount == -1)
      {
         amount = cash;
      }
      if (amount <= cash)
      {
         cash -= amount;
         bank += amount;
         break;
      } else {
         s_clrtobot(LINE3);
         fancy_numbers(cash, fancy_num);
         gl_printf(LEFT, LINE3, "Taipan, you only have %s", fancy_num);
         gl_write(LEFT, LINE4, "in cash.");

         s_timeout(5);
      }
   }
   port_stats();

   for (;;)
   {
      s_clrtobot(LINE1);
      gl_write(LEFT, LINE1, "Comprador's Report");
      gl_write(LEFT, LINE3, "How much will you withdraw?");

      amount = get_num(422, LINE3, 9);
      if (amount == -1)
      {
         amount = bank;
      }
      if (amount <= bank)
      {
         cash += amount;
         bank -= amount;
         break;
      } else {
         s_clrtobot(LINE3);
         fancy_numbers(bank, fancy_num);
         gl_printf(LEFT, LINE3, "Taipan, you only have %s", fancy_num);
         gl_write(LEFT, LINE4, "in the bank.");

         s_timeout(5);
      }
   }
   port_stats();

   return;
}

void transfer(void)
{
   int i, in_use;

   long amount = 0;

   if ((hkw_[0] == 0) && (hold_[0] == 0) &&
       (hkw_[1] == 0) && (hold_[1] == 0) &&
       (hkw_[2] == 0) && (hold_[2] == 0) &&
       (hkw_[3] == 0) && (hold_[3] == 0))
   {
      s_clrtobot(LINE7);
      gl_write(LEFT, LINE7, "You have no cargo, Taipan.");
      s_timeout(5);
      return;
   }

   for (i = 0; i < 4; i++)
   {
      if (hold_[i] > 0)
      {
         for (;;)
         {
            s_clrtobot(LINE1);
            gl_write(LEFT, LINE1, "Comprador's Report");
            gl_printf(LEFT, LINE3, "How much %s shall I move", item[i]);
            gl_write(LEFT, LINE4, "to the warehouse, Taipan?");

            amount = get_num(COL26, LINE4, 9);
            if (amount == -1)
            {
               amount = hold_[i];
            }
            if (amount <= hold_[i])
            {
               in_use = hkw_[0] + hkw_[1] + hkw_[2] + hkw_[3];
               if ((in_use + amount) <= 10000)
               {
                  hold_[i] -= amount;
                  hkw_[i] += amount;
                  hold += amount;
                  break;
               } else if (in_use == 10000) {
                  gl_write(LEFT, LINE6, "Your warehouse is full, Taipan!");
               } else {
                  gl_write(LEFT, LINE6, "Your warehouse will only hold an");
                  gl_printf(LEFT, LINE7, "additional %d, Taipan!", (10000 - in_use));

                  s_timeout(5);
               }
            } else {
               s_clrtobot(LINE3);
               gl_printf(LEFT, LINE3, "You have only %d, Taipan.", hold_[i]);

               s_timeout(5);
            }
         }
         port_stats();
      }

      if (hkw_[i] > 0)
      {
         for (;;)
         {
            s_clrtobot(LINE1);
            gl_write(LEFT, LINE1, "Comprador's Report");
            gl_printf(LEFT, LINE3, "How much %s shall I move", item[i]);
            gl_write(LEFT, LINE4, "aboard ship, Taipan?");

            amount = get_num(COL22, LINE4, 9);
            if (amount == -1)
            {
               amount = hkw_[i];
            }
            if (amount <= hkw_[i])
            {
               hold_[i] += amount;
               hkw_[i] -= amount;
               hold -= amount;
               break;
            } else {
               s_clrtobot(LINE3);
               gl_printf(LEFT, LINE3, "You have only %d, Taipan.", hkw_[i]);

               s_timeout(5);
            }
         }
         port_stats();
      }
   }

   return;
}

void quit(void)
{
   int choice = 0,
       result = 0;

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Taipan, do you wish me to go to:");
   gl_write(LEFT, LINE4, "1) Hong Kong, 2) Shanghai, 3) Nagasaki,");
   gl_write(LEFT, LINE5, "4) Saigon, 5) Manila, 6) Singapore, or");
   gl_write(LEFT, LINE6, "7) Batavia ?");

   for (;;)
   {
      s_clrtobot(LINE7);

      choice = get_num(210, LINE6, 1);

      if (choice == port)
      {
         gl_write(LEFT, LINE8, "You're already here, Taipan.");
         s_timeout(5);
      } else if ((choice >= 1) && (choice <= 7)) {
         port = choice;
         break;
      }
   }

   gl_write(COL30, ROW6, "         ");
   gl_setfont(14, 16, reverse);
   gl_printf(COL31, ROW6, "%s", location[0]);
   gl_setfont(14, 16, normal);

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Captain's Report");

   if (rand()%bp == 0)
   {
      int num_ships = rand()%((capacity / 10) + guns) + 1;

      if (num_ships > 9999)
      {
         num_ships = 9999;
      }
      gl_printf(LEFT, LINE3, "%d hostile ships approaching, Taipan!", num_ships);
      s_timeout(3);
      result = sea_battle(GENERIC, num_ships);
   }

   if (result == 2)
   {
      port_stats();
      gl_write(COL30, ROW6, "         ");
      gl_setfont(14, 16, reverse);
      gl_printf(COL31, ROW6, "%s", location[0]);
      gl_setfont(14, 16, normal);

      s_clrtobot(LINE1);
      gl_write(COL2, LINE1, "Captain's Report");
      gl_write(LEFT, LINE3, "Li Yuen's fleet drove them off!");
      s_timeout(3);
   }

   if (((result == 0) && (rand()%(4 + (8 * li))) == 0) || (result == 2))
   {
      s_clrtobot(LINE3);
      gl_write(LEFT, LINE3, "Li Yuen's pirates, Taipan!!");
      s_timeout(3);

      if (li > 0)
      {
         gl_write(LEFT, LINE5, "Good joss!! They let us be!!");

         s_timeout(3);

         return;
      } else {
         int num_ships = rand()%((capacity / 5) + guns) + 5;

         if (num_ships > 9999)
         {
            num_ships = 9999;
         }
         gl_printf(LEFT, LINE5, "%d ships of Li Yuen's pirate", num_ships);
         gl_write(LEFT, LINE6, "fleet, Taipan!!");

         s_timeout(3);

         sea_battle(LI_YUEN, num_ships);
      }
   }

   if (result > 0)
   {
      port_stats();
      gl_write(COL30, ROW6, "         ");
      gl_setfont(14, 16, reverse);
      gl_printf(COL31, ROW6, "%s", location[0]);
      gl_setfont(14, 16, normal);

      s_clrtobot(LINE1);
      gl_write(COL2, LINE1, "Captain's Report");

      if (result == 1)
      {
         fancy_numbers(booty, fancy_num);
         gl_write(LEFT, LINE3, "We captured some booty.");
         gl_printf(LEFT, LINE4, "It's worth %s!", fancy_num);
         cash += booty;
      } else if (result == 3) {
         gl_write(LEFT, LINE3, "We made it!");
      } else {
         gl_write(LEFT, LINE3, "The buggers got us, Taipan!!!");
         gl_write(LEFT, LINE4, "It's all over, now!!!");

         s_timeout(5);
         final_stats();
         return;
      }

      s_timeout(3);
   }

   if (rand()%10 == 0)
   {
      s_clrtobot(LINE3);
      gl_write(LEFT, LINE3, "Storm, Taipan!!");
      s_timeout(3);

      if (rand()%30 == 0)
      {
         gl_write(COL3, LINE5, "I think we're going down!!");
         s_timeout(3);

         if (((damage / capacity * 3) * ((float) rand() / RAND_MAX)) >= 1)
         {
            gl_write(LEFT, LINE7, "We're going down, Taipan!!");
            s_timeout(5);

            final_stats();
         } else {
            gl_write(LEFT, LINE7, "We made it!!");
            s_timeout(3);
         }
      } else {
         gl_write(LEFT, LINE5, "We made it!!");
         s_timeout(3);
      }

      if (rand()%3 == 0)
      {
         int orig = port;

         while (port == orig)
         {
            port = rand()%7 + 1;
         }

         s_clrtobot(LINE3);
         gl_write(LEFT, LINE3, "We've been blown off course");
         gl_printf(LEFT, LINE4, "to %s", location[port]);
         s_timeout(3);
      }
   }

   month++;
   if (month == 13)
   {
      month = 1;
      year++;
      ec += 10;
      ed += .5;
   }

   debt = debt + (debt * .1);
   bank = bank + (bank * .005);
   set_prices();

   s_clrtobot(LINE3);
   gl_printf(LEFT, LINE3, "Arriving at %s...", location[port]);

   s_timeout(3);

   return;
}

void li_yuen_extortion(void)
{
   int time = ((year - 1860) * 12) + month,
       choice = 0;

   float i = 1.8,
         j = 0,
         amount = 0;

   if (time > 12)
   {
      j = rand()%(1000 * time) + (1000 * time);
      i = 1;
   }

   amount = ((cash / i) * ((float) rand() / RAND_MAX)) + j;

   fancy_numbers(amount, fancy_num);

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_printf(LEFT, LINE3, "Li Yuen asks %s in donation", fancy_num);
   gl_write(LEFT, LINE4, "to the temple of Tin Hau, the Sea");
   gl_write(LEFT, LINE5, "Goddess.  Will you pay?");

   while ((choice != 'Y') && (choice != 'y') &&
          (choice != 'N') && (choice != 'n'))
   {
      choice = get_one(366, LINE5);
   }

   if ((choice == 'Y') || (choice == 'y'))
   {
      if (amount <= cash)
      {
         cash -= amount;
         li = 1;
      } else {
         s_clrtobot(LINE3);
         gl_write(LEFT, LINE3, "Taipan, you do not have enough cash!!");

         s_timeout(3);

         gl_write(LEFT, LINE5, "Do you want Elder Brother Wu to make up");
         gl_write(LEFT, LINE6, "the difference for you?");
         choice = 0;
         while ((choice != 'Y') && (choice != 'y') &&
                (choice != 'N') && (choice != 'n'))
         {
            choice = get_one(366, LINE6);
         }

         if ((choice == 'Y') || (choice == 'y'))
         {
            amount -= cash;
            debt += amount;
            cash = 0;
            li = 1;

            s_clrtobot(LINE3);
            gl_write(LEFT, LINE3, "Elder Brother has given Li Yuen the");
            gl_write(LEFT, LINE4, "difference between what he wanted and");
            gl_write(LEFT, LINE5, "your cash on hand and added the same");
            gl_write(LEFT, LINE6, "amount to your debt.");

            s_timeout(5);
         } else {
            cash = 0;

            s_clrtobot(LINE3);
            gl_write(LEFT, LINE3, "Very well. Elder Brother Wu will not pay");
            gl_write(LEFT, LINE4, "Li Yuen the difference.  I would be very");
            gl_write(LEFT, LINE5, "wary of pirates if I were you, Taipan.");

            s_timeout(5);
         }
      }
   }

   port_stats();

   return;
}

void elder_brother_wu(void)
{
   int  choice = 0;

   long wu = 0;

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Do you have business with Elder Brother");
   gl_write(LEFT, LINE4, "Wu, the moneylender?");

   for (;;)
   {
      choice = get_one(324, LINE4);
      if ((choice == 'N') || (choice == 'n'))
      {
         break;
      } else if ((choice == 'Y') || (choice == 'y')) {
         if (((int)cash == 0) && ((int)bank == 0) && (guns == 0) &&
             (hold_[0] == 0) && (hkw_[0] == 0) &&
             (hold_[1] == 0) && (hkw_[1] == 0) &&
             (hold_[2] == 0) && (hkw_[2] == 0) &&
             (hold_[3] == 0) && (hkw_[3] == 0))
         {
            int i = rand()%1500 + 500,
                j;

            wu_bailout++;
            j = rand()%2000 * wu_bailout + 1500;

            for (;;)
            {
               s_clrtobot(LINE1);
               gl_write(LEFT, LINE1, "Comprador's Report");
               gl_write(LEFT, LINE3, "Elder Brother is aware of your plight,");
               gl_write(LEFT, LINE4, "Taipan.  He is willing to loan you an");
               gl_printf(LEFT, LINE5, "additional %d if you will pay back", i);
               gl_printf(LEFT, LINE6, "%d. Are you willing, Taipan?", j);

               choice = get_one(COL32, LINE6);
               if ((choice == 'N') || (choice == 'n'))
               {
                  s_clrtobot(LINE1);
                  gl_write(LEFT, LINE1, "Comprador's Report");
                  gl_write(LEFT, LINE3, "Very well, Taipan, the game is over!");

                  s_timeout(5);

                  final_stats();
               } else if ((choice == 'Y') || (choice == 'y')) {
                  cash += i;
                  debt += j;
                  port_stats();

                  s_clrtobot(LINE1);
                  gl_write(LEFT, LINE1, "Comprador's Report");
                  gl_write(LEFT, LINE3, "Very well, Taipan.  Good joss!!");

                  s_timeout(5);

                  return;
               }
            }
         } else if ((cash > 0) && (debt != 0)) {
            for (;;)
            {
               s_clrtobot(LINE1);
               gl_write(LEFT, LINE1, "Comprador's Report");
               gl_write(LEFT, LINE3, "How much do you wish to repay");
               gl_write(LEFT, LINE4, "him?");

               wu = get_num(100, LINE4, 9);
               if (wu == -1)
               {
                  wu = cash;
               }
               if (wu <= cash)
               {
                  cash -= wu;
                  if ((wu > debt) && (debt > 0))
                  {
                     debt -= (wu + 1);
                  } else {
                     debt -= wu;
                  }
                  break;
               } else {
                  s_clrtobot(LINE3);
                  fancy_numbers(cash, fancy_num);
                  gl_printf(LEFT, LINE3, "Taipan, you only have %s", fancy_num);
                  gl_write(LEFT, LINE4, "in cash.");

                  s_timeout(10);
               }
            }
         }
         port_stats();

         for (;;)
         {
            s_clrtobot(LINE1);
            gl_write(LEFT, LINE1, "Comprador's Report");
            gl_write(LEFT, LINE3, "How much do you wish to");
            gl_write(LEFT, LINE4, "borrow?");

            wu = get_num(142, LINE4, 9);
            if (wu == -1)
            {
               wu = (cash * 2);
            }
            if (wu <= (cash * 2))
            {
               cash += wu;
               debt += wu;
               break;
            } else {
               gl_write(LEFT, LINE6, "He won't loan you so much, Taipan!");

               s_timeout(5);
            }
         }
         port_stats();

         break;
      }
   }

   if ((debt > 20000) && (cash > 0) && (rand()%5 == 0))
   {
      int num = rand()%3 + 1;

      cash = 0;
      port_stats();

      s_clrtobot(LINE1);
      gl_write(LEFT, LINE1, "Comprador's Report");
      gl_write(LEFT, LINE3, "Bad joss!!");
      gl_printf(LEFT, LINE4, "%d of your bodyguards have been killed", num);
      gl_write(LEFT, LINE5, "by cutthroats and you have been robbed");
      gl_write(LEFT, LINE6, "of all of your cash, Taipan!!");

      s_timeout(5);
   }
}

void good_prices(void)
{
   char item[14];

   int i = rand()%4,
       j = rand()%2;

   if (i == 0)
   {
      strcpy(item, "Opium");
   } else if (i == 1) {
      strcpy(item, "Silk");
   } else if (i == 2) {
      strcpy(item, "Arms");
   } else {
      strcpy(item, "General Cargo");
   }

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_printf(LEFT, LINE3, "Taipan!!  The price of %s", item);
   if (j == 0)
   {
      price[i] = price[i] / 5;
      gl_printf(LEFT, LINE4, "has dropped to %ld!!", price[i]);
   } else {
      price[i] = price[i] * (rand()%5 + 5);
      gl_printf(LEFT, LINE4, "has risen to %ld!!", price[i]);
   }

   s_timeout(3);
}

void overload(void)
{
   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Your ship is overloaded, Taipan!!");
   s_timeout(5);
   return;
}

void new_ship(void)
{
   int  choice = 0,
        time;

   float amount;

   time = ((year - 1860) * 12) + month;
   amount = rand()%(1000 * (time + 5) / 6) * (capacity / 50) + 1000;

   if (cash < amount)
   {
      return;
   }

   fancy_numbers(amount, fancy_num);

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Do you wish to trade in your ");
   if (damage > 0)
   {
      gl_setfont(14, 16, reverse);
      gl_write(COL29, LINE3, "damaged");
      gl_setfont(14, 16, normal);
   } else {
      gl_write(COL29, LINE3, "fine");
   }
   gl_write(LEFT, LINE4, "ship for one with 50 more capacity by");
   gl_printf(LEFT, LINE5, "paying an additional %s, Taipan?", fancy_num);

   while ((choice != 'Y') && (choice != 'y') &&
          (choice != 'N') && (choice != 'n'))
   {
      choice = get_one((464 + (strlen(fancy_num) * 14)), LINE5);
   }

   if ((choice == 'Y') || (choice == 'y'))
   {
      cash -= amount;
      hold += 50;
      capacity += 50;
      damage = 0;
   }

   if ((rand()%2 == 0) && (guns < 1000))
   {
      port_stats();
      new_gun();
   }

   port_stats();

   return;
}

void new_gun(void)
{
   int choice = 0,
       time;

   float amount;

   time = ((year - 1860) * 12) + month;
   amount = rand()%(1000 * (time + 5) / 6) + 500;

   if ((cash < amount) || (hold < 10))
   {
      return;
   }

   fancy_numbers(amount, fancy_num);

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Do you wish to buy a ship's gun");
   gl_printf(LEFT, LINE4, "for %s, Taipan?", fancy_num);

   while ((choice != 'Y') && (choice != 'y') &&
          (choice != 'N') && (choice != 'n'))
   {
      choice = get_one((226 + (strlen(fancy_num) * 14)), LINE4);
   }

   if ((choice == 'Y') || (choice == 'y'))
   {
      cash -= amount;
      hold -= 10;
      guns += 1;
   }

   port_stats();

   return;
}

void fancy_numbers(float num, char *fancy)
{
   char number[18];

   if (num >= 100000000)
   {
      int num1 = (num / 1000000);
      sprintf(number, "%d", num1);
      strcpy(fancy, number);
      strcat(fancy, " Million");
   } else if (num >= 10000000) {
      int num1 = (num / 1000000);
      int num2 = (((int) num % 1000000) / 100000);
      sprintf(number, "%d", num1);
      strcpy(fancy, number);
      if (num2 > 0)
      {
         strcat(fancy, ".");
         sprintf(number, "%d", num2);
         strcat(fancy, number);
      }
      strcat(fancy, " Million");
   } else if (num >= 1000000) {
      int num1 = (num / 1000000);
      int num2 = (((int) num % 1000000) / 10000);
      sprintf(number, "%d", num1);
      strcpy(fancy, number);
      if (num2 > 0)
      {
         strcat(fancy, ".");
         sprintf(number, "%d", num2);
         strcat(fancy, number);
      }
      strcat(fancy, " Million");
   } else {
      sprintf(number, "%d", (int) num);
      strcpy(fancy, number);
   }
}

int sea_battle(int id, int num_ships)
{
   char ships[(CHARWIDTH * 40) * (CHARHEIGHT * 18)];

   int orders = 0,
       num_on_screen = 0,
       ships_on_screen[10],
       time = ((year - 1860) * 12) + month,
       s0 = num_ships,
       ok = 0,
       ik = 1,
       x, y, i,
       input,
       status;

   booty = (time / 4 * 1000 * num_ships) + rand()%1000 + 250;

   for (i = 0; i <= 9; i++)
   {
      ships_on_screen[i] = 0;
   }

   gl_clearscreen(0);
   fight_stats(num_ships, orders);

   while (num_ships > 0)
   {
      status = 100 - (((float) damage / capacity) * 100);
      if (status <= 0)
      {
         return 4;
      }
      s_clearline(ROW3);
      gl_printf(LEFT, ROW3, "Current seaworthiness: %s (%d%%)",
                             st[(status / 20)], status);

      x = LEFT;
      y = ROW6;
      for (i = 0; i <= 9; i++)
      {
         if (i == 5)
         {
            x = LEFT;
            y = ROW12;
         }

         if (num_ships > num_on_screen)
         {
            if (ships_on_screen[i] == 0)
            {
               usleep(100000);
               ships_on_screen[i] =
                (int)((ec * ((float) rand() / RAND_MAX)) + 20);
               draw_lorcha(x, y);
               num_on_screen++;
            }

            x += (CHARWIDTH * 8);
         }
      }

      if (num_ships > num_on_screen)
      {
         gl_write(COL39, ROW11, "+");
      } else {
         gl_write(COL39, ROW11, " ");
      }

      input = s_timeout(3);

      if ((input == 'F') || (input == 'f'))
      {
         orders = 1;
      } else if ((input == 'R') || (input == 'r')) {
         orders = 2;
      } else if ((input == 'T') || (input == 't')) {
         orders = 3;
      }

      if (orders == 0)
      {
         input = s_timeout(3);

         if ((input == 'F') || (input == 'f'))
         {
            orders = 1;
         } else if ((input == 'R') || (input == 'r')) {
            orders = 2;
         } else if ((input == 'T') || (input == 't')) {
            orders = 3;
         } else {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "Taipan, what shall we do??    (f,r,t)");
            while ((input != 'F') && (input != 'f') &&
                   (input != 'R') && (input != 'r') &&
                   (input != 'T') && (input != 't'))
            {
               input = get_one(COL27, ROW3);
            }
            if ((input == 'F') || (input == 'f'))
            {
               orders = 1;
            } else if ((input == 'R') || (input == 'r')) {
               orders = 2;
            } else {
               orders = 3;
            }
         }
      }

      fight_stats(num_ships, orders);
      if ((orders == 1) && (guns > 0))
      {
         int targeted,
             sk = 0;

         ok = 3;
         ik = 1;
         s_clearline(ROW3);
         gl_write(LEFT, ROW3, "Aye, we'll fight 'em, Taipan.");
         s_timeout(3);

         s_clearline(ROW3);
         gl_write(LEFT, ROW3, "We're firing on 'em, Taipan!");
         s_timeout(1);

         for (i = 1; i <= guns; i++)
         {
            if ((ships_on_screen[0] == 0) && (ships_on_screen[1] == 0) &&
                (ships_on_screen[2] == 0) && (ships_on_screen[3] == 0) &&
                (ships_on_screen[4] == 0) && (ships_on_screen[5] == 0) &&
                (ships_on_screen[6] == 0) && (ships_on_screen[7] == 0) &&
                (ships_on_screen[8] == 0) && (ships_on_screen[9] == 0))
            {
               int j;

               x = LEFT;
               y = ROW6;
               for (j = 0; j <= 9; j++)
               {
                  if (j == 5)
                  {
                     x = LEFT;
                     y = ROW12;
                  }

                  if (num_ships > num_on_screen)
                  {
                     if (ships_on_screen[j] == 0)
                     {
                        usleep(100000);
                        ships_on_screen[j] =
                         (int)((ec * ((float) rand() / RAND_MAX)) + 20);
                        draw_lorcha(x, y);
                        num_on_screen++;
                     }

                     x += (CHARWIDTH * 8);
                  }
               }
            }

            if (num_ships > num_on_screen)
            {
               gl_write(COL39, ROW11, "+");
            } else {
               gl_write(COL39, ROW11, " ");
            }

            targeted = rand()%10;
            while (ships_on_screen[targeted] == 0)
            {
               targeted = rand()%10;
            }

            x = (targeted < 5) ? (LEFT + (targeted * (CHARWIDTH * 8))) :
                                 (LEFT + ((targeted - 5) * (CHARWIDTH * 8)));
            y = (targeted < 5) ? ROW6 : ROW12;

            draw_blast(x, y);

            ships_on_screen[targeted] -= rand()%30 + 10;

            if (ships_on_screen[targeted] <= 0)
            {
               num_on_screen--;
               num_ships--;
               sk++;
               ships_on_screen[targeted] = 0;

               usleep(100000);

               sink_lorcha(x, y);

               if (num_ships == num_on_screen)
               {
                  gl_write(COL39, ROW11, " ");
               }

               fight_stats(num_ships, orders);
            }

            if (num_ships == 0)
            {
               i += guns;
            } else {
               usleep(500000);
            }
         }
         s_clearline(ROW3);
         if (sk > 0)
         {
            gl_printf(LEFT, ROW3, "Sunk %d of the buggers, Taipan!", sk);
         } else {
            gl_write(LEFT, ROW3, "Hit 'em, but didn't sink 'em, Taipan!");
         }
         s_timeout(3);

         if ((rand()%s0 > (num_ships * .6 / id)) && (num_ships > 2))
         {
            int ran = rand()%(num_ships / 3 / id) + 1;

            num_ships -= ran;
            fight_stats(num_ships, orders);
            s_clearline(ROW3);
            gl_printf(LEFT, ROW3, "%d ran away, Taipan!", ran);

            if (num_ships <= 10)
            {
               for (i = 9; i >= 0; i--)
               {
                  if ((num_on_screen > num_ships) && (ships_on_screen[i] > 0))
                  {
                     ships_on_screen[i] = 0;
                     num_on_screen--;

                     x = (i < 5) ? (LEFT + (i * (CHARWIDTH * 8))) :
                                   (LEFT + ((i - 5) * (CHARWIDTH * 8)));
                     y = (i < 5) ? ROW6 : ROW12;
                     clear_lorcha(x, y);
                     usleep(100000);
                  }
               }
               if (num_ships == num_on_screen)
               {
                  gl_write(COL39, ROW11, " ");
               }
            }

            input = s_timeout(3);

            if ((input == 'F') || (input == 'f'))
            {
               orders = 1;
            } else if ((input == 'R') || (input == 'r')) {
               orders = 2;
            } else if ((input == 'T') || (input == 't')) {
               orders = 3;
            }
         }
      } else if ((orders == 1) && (guns == 0)) {
         s_clearline(ROW3);
         gl_write(LEFT, ROW3, "We have no guns, Taipan!!");
         s_timeout(3);
      } else if (orders == 3) {
         int  choice = 0;

         long amount = 0,
              total = 0;

         s_clearline(ROW3);
         gl_write(LEFT, ROW3, "What shall I throw overboard, Taipan?");

         gl_write(LEFT, LINE3, "You have the following on board, Taipan:");
         gl_printf(COL4, LINE4, "Opium: %d", hold_[0]);
         gl_printf(COL24, LINE4, "Silk: %d", hold_[1]);
         gl_printf(COL5, LINE5, "Arms: %d", hold_[2]);
         gl_printf(COL21, LINE5, "General: %d", hold_[3]);

         while ((choice != 'O') && (choice != 'o') &&
                (choice != 'S') && (choice != 's') &&
                (choice != 'A') && (choice != 'a') &&
                (choice != 'G') && (choice != 'g') &&
                (choice != '*'))
         {
            choice = get_one(COL38, ROW3);
         }

         if ((choice == 'O') || (choice == 'o'))
         {
            choice = 0;
         } else if ((choice == 'S') || (choice == 's')) {
            choice = 1;
         } else if ((choice == 'A') || (choice == 'a')) {
            choice = 2;
         } else if ((choice == 'G') || (choice == 'g')) {
            choice = 3;
         } else {
            choice = 4;
         }

         if (choice < 4)
         {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "How much, Taipan?");

            amount = get_num(COL18, ROW3, 9);
            if ((hold_[choice] > 0) && ((amount == -1) || (amount > hold_[choice])))
            {
               amount = hold_[choice];
            }
            total = hold_[choice];
         } else {
            total = hold_[0] + hold_[1] + hold_[2] + hold_[3];
         }

         if (total > 0)
         {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "Let's hope we lose 'em, Taipan!");
            if (choice < 4)
            {
               hold_[choice] -= amount;
               hold += amount;
               ok += (amount / 10);
            } else {
               hold_[0] = 0;
               hold_[1] = 0;
               hold_[2] = 0;
               hold_[3] = 0;
               hold += total;
               ok += (total / 10);
            }
            gl_fillbox(LEFT, LINE3, (CHARWIDTH * 40), (CHARHEIGHT * 3), 0);
            s_timeout(3);
         } else {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "There's nothing there, Taipan!");
            gl_fillbox(LEFT, LINE3, (CHARWIDTH * 40), (CHARHEIGHT * 3), 0);
            s_timeout(3);
         }
      }

      if ((orders == 2) || (orders == 3))
      {
         if (orders == 2)
         {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "Aye, we'll run, Taipan.");
            s_timeout(3);
         }

         ok += ik++;
         if ((rand()%ok) > (rand()%num_ships))
         {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "We got away from 'em, Taipan!");
            s_timeout(3);
            num_ships = 0;
         } else {
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "Couldn't lose 'em.");
            s_timeout(3);

            if ((num_ships > 2) && (rand()%5 == 0))
            {
               int lost = (rand()%num_ships / 2) + 1;

               num_ships -= lost;
               fight_stats(num_ships, orders);
               s_clearline(ROW3);
               gl_printf(LEFT, ROW3, "But we escaped from %d of 'em!", lost);

               if (num_ships <= 10)
               {
                  for (i = 9; i >= 0; i--)
                  {
                     if ((num_on_screen > num_ships) && (ships_on_screen[i] > 0))
                     {
                        ships_on_screen[i] = 0;
                        num_on_screen--;

                        x = (i < 5) ? (LEFT + (i * (CHARWIDTH * 8))) :
                                      (LEFT + ((i - 5) * (CHARWIDTH * 8)));
                        y = (i < 5) ? ROW6 : ROW12;
                        clear_lorcha(x, y);
                        usleep(100000);
                     }
                  }
                  if (num_ships == num_on_screen)
                  {
                     gl_write(COL39, ROW11, " ");
                  }
               }

               input = s_timeout(3);

               if ((input == 'F') || (input == 'f'))
               {
                  orders = 1;
               } else if ((input == 'R') || (input == 'r')) {
                  orders = 2;
               } else if ((input == 'T') || (input == 't')) {
                  orders = 3;
               }
            }
         }
      }

      if (num_ships > 0)
      {
         gl_getbox(LEFT, ROW6, (CHARWIDTH * 40), (CHARHEIGHT * 18), ships);

         s_clearline(ROW3);
         gl_write(LEFT, ROW3, "They're firing on us, Taipan!");
         s_timeout(3);
         for (i = 0; i < 3; i++)
         {
            gl_clearscreen(15);
            usleep(100000);
            gl_clearscreen(0);
            usleep(100000);
         }

         gl_putbox(LEFT, ROW6, (CHARWIDTH * 40), (CHARHEIGHT * 18), ships);

         fight_stats(num_ships, orders);
         gl_write(LEFT, ROW3, "We've been hit, Taipan!!");
         s_timeout(3);

         i = (num_ships > 15) ? 15 : num_ships;
         if ((guns > 0) && ((rand()%100 < (((float) damage / capacity) * 100)) ||
             ((((float) damage / capacity) * 100) > 80)))
         {
            i = 1;
            guns--;
            hold += 10;
            s_clearline(ROW3);
            gl_write(LEFT, ROW3, "The buggers hit a gun, Taipan!!");
            fight_stats(num_ships, orders);
            s_timeout(3);
         }
         damage = damage + ((ed * i * id) * ((float) rand() / RAND_MAX)) + (i / 2);
         if ((id == GENERIC) && (rand()%20 == 0))
         {
            return 2;
         }
      }
   }

   if (orders == 1)
   {
      fight_stats(num_ships, orders);
      s_clearline(ROW3);
      gl_write(LEFT, ROW3, "We got 'em all, Taipan!");
      s_timeout(3);
      return 1;
   } else {
      return 3;
   }
}

void fight_stats(int ships, int orders)
{
   char ch_orders[12];

   int i;

   if (orders == 0)
   {
      strcpy(ch_orders, "\0");
   } else if (orders == 1) {
      strcpy(ch_orders, "Fight      ");
   } else if (orders == 2) {
      strcpy(ch_orders, "Run        ");
   } else {
      strcpy(ch_orders, "Throw Cargo");
   }

   if (ships >= 1000)
   {
      gl_printf(LEFT, TOP, "%d", ships);
   } else if (ships >= 100) {
      gl_printf(LEFT, TOP, " %d", ships);
   } else if (ships >= 10) {
      gl_printf(LEFT, TOP, "  %d", ships);
   } else {
      gl_printf(LEFT, TOP, "   %d", ships);
   }
   if (ships == 1)
   {
      gl_write(COL5, TOP, "ship attacking, Taipan! ");
   } else {
      gl_write(COL5, TOP, "ships attacking, Taipan!");
   }
   gl_printf(COL31, TOP, "%c We have", SINGLEVER);
   gl_printf(LEFT, ROW1, "Your orders are to: %s", ch_orders);
   gl_printf(COL31, ROW1, "%c", SINGLEVER);
   if (guns >= 100)
   {
      gl_printf(COL32, ROW1, "%d", guns);
   } else if (guns >= 10) {
      gl_printf(COL32, ROW1, " %d", guns);
   } else {
      gl_printf(COL32, ROW1, "  %d", guns);
   }
   gl_write(COL36, ROW1, "guns");
   gl_printf(COL31, ROW2, "%c", LLCORNER);
   for (i = COL32; i <= COL39; i += CHARWIDTH)
   {
      gl_printf(i, ROW2, "%c", SINGLEBOT);
   }

   return;
}

void mchenry(void)
{
   int choice = 0;

   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_write(LEFT, LINE3, "Taipan, Mc Henry from the Hong Kong");
   gl_write(LEFT, LINE4, "Shipyards has arrived!!  He says, \"I see");
   gl_write(LEFT, LINE5, "ye've a wee bit of damage to yer ship.");
   gl_write(LEFT, LINE6, "Will ye be wanting repairs?");

   while ((choice != 'Y') && (choice != 'y') &&
          (choice != 'N') && (choice != 'n'))
   {
      choice = get_one(422, LINE6);
   }

   if ((choice == 'Y') || (choice == 'y'))
   {
      int  percent = ((float) damage / capacity) * 100,
           time = ((year - 1860) * 12) + month;

      long br = ((((60 * (time + 3) / 4) * (float) rand() / RAND_MAX) +
                25 * (time + 3) / 4) * capacity / 50),
           repair_price = (br * damage) + 1,
           amount;

      s_clrtobot(LINE3);
      gl_printf(LEFT, LINE3, "Och, 'tis a pity to be %d%% damaged.", percent);
      gl_printf(LEFT, LINE4, "We can fix yer whole ship for %ld,", repair_price);
      gl_write(LEFT, LINE5, "or make partial repairs if you wish.");
      gl_write(LEFT, LINE6, "How much will ye spend?");

      for (;;)
      {
         amount = get_num(366, LINE6, 9);
         if (amount == -1)
         {
            amount = cash;
         }
         if (amount <= cash)
         {
            cash -= amount;
            damage -= (int)((amount / br) + .5);
            damage = (damage < 0) ? 0 : damage;
            port_stats();
            break;
         }
      }
   }

   return;
}

void retire(void)
{
   s_clrtobot(LINE1);
   gl_write(LEFT, LINE1, "Comprador's Report");
   gl_setfont(14, 16, reverse);
   gl_write(LEFT, LINE3, "                         ");
   gl_write(LEFT, LINE4, " Y o u ' r e    a        ");
   gl_write(LEFT, LINE5, "                         ");
   gl_write(LEFT, LINE6, " M I L L I O N A I R E ! ");
   gl_write(LEFT, LINE7, "                         ");
   gl_setfont(14, 16, normal);
   s_timeout(5);

   final_stats();
}

void final_stats(void)
{
   char s1[2], s2[2];

   int years = year - 1860,
       time = ((year - 1860) * 12) + month,
       choice = 0,
       i;

   if (years != 1)
   {
      strcpy(s1, "s");
   } else {
      strcpy(s1, '\0');
   }
   if (month > 1)
   {
      strcpy(s2, "s");
   } else {
      strcpy(s2, '\0');
   }

   gl_clearscreen(0);
   gl_write(LEFT, TOP, "Your final status:");
   cash = cash + bank - debt;
   fancy_numbers(cash, fancy_num);
   gl_printf(LEFT, ROW2, "Net cash:  %s", fancy_num);
   gl_printf(LEFT, ROW4, "Ship size: %d units with %d guns", capacity, guns);
   gl_printf(LEFT, ROW6, "You traded for %d year%s and %d month%s",
             years, s1, month, s2);
   cash = cash / 100 / time;
   gl_setfont(14, 16, reverse);
   gl_printf(LEFT, ROW8, "Your score is %.0f.", cash);
   gl_setfont(14, 16, normal);
   if ((cash < 100) && (cash >= 0))
   {
      gl_write(LEFT, ROW10, "Have you considered a land based job?");
   } else if (cash < 0) {
      gl_write(LEFT, ROW10, "The crew has requested that you stay on");
      gl_write(LEFT, ROW11, "shore for their safety!!");
   }
   gl_write(LEFT, ROW13, "Your Rating:");

   gl_printf(LEFT, ROW14, "%c", ULCORNER);
   for (i = COL1; i <= COL32; i += CHARWIDTH)
   {
      gl_printf(i, ROW14, "%c", SINGLETOP);
   }
   gl_printf(COL32, ROW14, "%c", URCORNER);
   for (i = ROW15; i <= LINE4; i += CHARHEIGHT)
   {
      gl_printf(LEFT, i, "%c", SINGLEVER);
      gl_printf(COL32, i, "%c", SINGLEVER);
   }
   gl_printf(LEFT, LINE5, "%c", LLCORNER);
   for (i = COL1; i <= COL32; i += CHARWIDTH)
   {
      gl_printf(i, LINE5, "%c", SINGLEBOT);
   }
   gl_printf(COL32, LINE5, "%c", LRCORNER);

   if (cash > 49999)
   {
      gl_setfont(14, 16, reverse);
   }
   gl_write(COL1, ROW15, "Ma Tsu");
   gl_setfont(14, 16, normal);
   gl_write(COL16, ROW15, "50,000 and over");
   if ((cash < 50000) && (cash > 7999))
   {
      gl_setfont(14, 16, reverse);
   }
   gl_write(COL1, LINE1, "Master Taipan");
   gl_setfont(14, 16, normal);
   gl_write(COL17, LINE1, "8,000 to 49,999");
   if ((cash < 8000) && (cash > 999))
   {
      gl_setfont(14, 16, reverse);
   }
   gl_write(COL1, LINE2, "Taipan");
   gl_setfont(14, 16, normal);
   gl_write(COL17, LINE2, "1,000 to  7,999");
   if ((cash < 1000) && (cash > 499))
   {
      gl_setfont(14, 16, reverse);
   }
   gl_write(COL1, LINE3, "Compradore");
   gl_setfont(14, 16, normal);
   gl_write(COL19, LINE3, "500 to    999");
   if (cash < 500)
   {
      gl_setfont(14, 16, reverse);
   }
   gl_write(COL1, LINE4, "Galley Hand");
   gl_setfont(14, 16, normal);
   gl_write(COL19, LINE4, "less than 500");

   gl_write(COL1, LINE7, "Play again?");
   while ((choice != 'Y') && (choice != 'y') &&
          (choice != 'N') && (choice != 'n'))
   {
      choice = get_one(COL12, LINE7);
   }

   if ((choice == 'Y') || (choice == 'y'))
   {
      firm[0] = '\0';

      bank         = 0;
      hkw_[0]      = 0;
      hkw_[1]      = 0;
      hkw_[2]      = 0;
      hkw_[3]      = 0;
      hold_[0]     = 0;
      hold_[1]     = 0;
      hold_[2]     = 0;
      hold_[3]     = 0;
      hold         = 0;
      capacity     = 60;
      damage       = 0;
      month        = 1;
      year         = 1860;
      port         = 1;

      splash_intro();
      name_firm();
      cash_or_guns();
      set_prices();

      return;
   }

   gl_clearscreen(0);
   vga_setmode(TEXT);

   exit(0);
}
